
/* ############################################################################# */

#define	farZ	oblv_ProjectionDepthRange_CURRENTPASS.x
#define	nearZ	oblv_ProjectionDepthRange_CURRENTPASS.y
#define	rangeZ	oblv_ProjectionDepthRange_CURRENTPASS.z
#define	sumZ	oblv_ProjectionDepthRange_CURRENTPASS.w
// .x - nearZ
// .y - farZ
// .z - farZ - nearZ
// .w - farZ + nearZ
float4 oblv_ProjectionDepthRange_CURRENTPASS : register(c0);

// w = cot(fieldOfViewX / 2).
// h = w / aspectRatio.
//
// w       0       0                                                    0
// 0       h       0                                                    0
// 0       0                    zfarPlane / (znearPlane - zfarPlane)   -1
// 0       0       znearPlane * zfarPlane / (znearPlane - zfarPlane)    0
matrix oblv_ProjectionTransform_CURRENTPASS : register(c1);

/* ############################################################################# */

sampler2D DpthSampler : register(s0);

/* ############################################################################# */

#define	ProjectionA	oblv_ProjectionTransform_CURRENTPASS[2][2]
#define	ProjectionB	oblv_ProjectionTransform_CURRENTPASS[3][2]

float LinearDepth(float2 coord) {
//	return (ProjectionB / (tex2D(DpthSampler, coord).x - ProjectionA)) / rangeZ;
	return ProjectionB / ((tex2D(DpthSampler, coord).x - ProjectionA) * rangeZ);
}

float PassedDepth(float2 coord) {
	return tex2D(DpthSampler, coord).x;
}

/* ----------------------------------------------------------------------------- */

float WaterDepth(float2 coord) {
	return tex2D(DpthSampler, coord).x;
}
